/*	duscc.h	 MIRS99054	*/
/*	Definition of DUSCC Register Address	PEP BUG Settings Data */
/*	last update 00/07/22	*/

#define	CMR1	0xfdfc81	/*	Channel Mode Register1		0x07*/
#define	CMR2	0xfdfc83	/*	Channel Mode Register2		0x38*/
#define	S1R	0xfdfc85	/*	SYN 1/Secondary Address 1 Register 0x00	*/
#define	S2R	0xfdfc87	/*	SYN 2/Secondary Address 2 Register 0x00	*/
#define	TPR	0xfdfc89	/*	Transmitter Parameter Register	0x77*/
#define	TTR	0xfdfc8b	/*	Transmitter Timing Register	0x3d*/
#define	RPR	0xfdfc8d	/*	Receiver Parameter Register	0x1b*/
#define	RTR	0xfdfc8f	/*	Receiver Timing Register	0x2d*/
#define	CTPRH	0xfdfc91	/*	Counter/Timer Preset Register High  0xff*/
#define	CTPRL	0xfdfc93	/*	Counter/Timer Preset Register Low   0xff*/
#define	CTCR	0xfdfc95	/*	Counter/Timer Control Register	0x00*/
#define	RS_OMR	0xfdfc97	/*	Output and Miscellaneous Register 0xf3*/
#define	CTH	0xfdfc99	/*	Counter/Timer High	0xff*/
#define	CTL	0xfdfc9b	/*	Counter/Timer Low	0xff*/
#define	PCR	0xfdfc9d	/*	Pin Configuration Register 0x20*/
#define	CCR	0xfdfc9f	/*	Channel Command Register   0x72*/
#define	TxFIFO	0xfdfca1	/*	Transmitter FIFO 0xff*/
#define	RxFIFO	0xfdfca9	/*	Receiver FIFO	0xff*/
#define	RSR	0xfdfcb1	/*	Receiver Status Register 0xff*/
#define	TRSR	0xfdfcb3	/*	Transmitter and Receiver Status Register 0xff*/
#define	ICTSR	0xfdfcb5	/*	Input and Counter/Timer Status Register	0xff*/
#define	GSR	0xfdfcb7	/*	General Status Register	0xff*/
#define	IER	0xfdfcb9	/*	Interrupt Enable Register 0xff*/
#define	ICR	0xfdfcbf	/*	Interrupt Control Register 0xff*/

#define	IVR	0xfdfcbd	/*	Interrupt Vector Register - Unmodified	0xff*/
#define	IVRM	0xfdfcfd	/*	Interrupt Vector Register - Modified	0xff*/


/*	Definition of DUSCC Command	*/

#define	RST_Tx		0x00	/*	Reset Tx	*/
#define	RST_TxCRC	0x01	/*	Reset TxCRC	*/
#define	EBL_Tx		0x02	/*	Enable Tx	*/
#define	DEBL_Tx		0x03	/*	Disenable Tx	*/
#define	RST_Rx		0x40	/*	Reset Rx	*/
#define	EBL_Rx		0x42	/*	Enable Rx	*/
#define	DEBL_Rx		0x43	/*	Disenable Rx	*/

/*	Definition of Vector Number for DUSCC	*/

#define	VCT	64

/*	other	symboles	*/

#define	BUFSIZE	255
#define	CR	0x0d
#define ESC     0x1b

#ifndef NULL
#define	NULL	0x00
#endif

#define	ACTIVE	1
#define NON     -1      /*      Non_adaptive    */

