/***task02*******************************/
/*	MIRS9905 task02			*/
/*		Ȉʒuo task	*/
/****************************************/

#include "mirx68k.h"  		/* MIRX68K */
#include "hard.h"		/* Hardware function library */
#include "defs.h"

#define ST_02 15

#define PAI_H  1.57f

#define B_CCW	0.128f  	/* ^CԊûP^Q [m] for CCW */
#define B_CW	0.12423f	/* ^CԊûP^Q [m] for CW */


#define Kv	COEF		/* x̌W */
#define Kw_CW	(COEF/B_CW)	/* omega(turn right̎)̌W */ 
#define Kw_CCW	(COEF/B_CCW)	/* omega(turn left̎)̌W */

#define DEG(x)	(x/PI*180.0f)	/* 180/(change from radian to degree) */

#define INIT_X	(0.0f)		/* xW(Initial X-coordinate) */
#define INIT_Y	(0.0f)		/* yW(Initial Y-coordinate) */
#define INIT_TH	(PAI_H)		/* pp(Initial Theta coordinate) */

extern float cosf(float);	/* cos(x)̌vZ(cosinus function) */
extern float sinf(float);	/* sin(x)̌vZ(sinus function) */

static float	x_thre=135.0f;	/* xW̍ől(x-axis limit) */
static float	y_thre=135.0f;	/* yW̍ől(y-axis limit) */

static float	re_x=INIT_X;	/* xW[cm] */
static float	re_y=INIT_Y;	/* yW[cm] */
static float	re_th=INIT_TH;	/* pp[rad] */
static float	w;	/* px(omega)[rad/sec] */
static float 	len;	/* ړ */

void inzt02()						/* ݒ^XN */
{
	rs_snd("task02 inzt\n");
	sys0(2,0x1010);
	
	sys8(2,0,(int)(INIT_X));	/* xWf[^̐ݒ(ʒu) */
	sys8(2,1,(int)(INIT_Y));	/* YWf[^̐ݒ(ʒu) */
	sys8(2,2,(int)(DEG(INIT_TH)));	/* ppf[^̐ݒ(ʒu) */
	sys8(2,3,0);	/* E[^GR[_[(RE)f[^(pX) */
	sys8(2,4,0);	/* REf[^(pX) */
	sys8(2,5,0);	/* ^b`ZT(TS) f[^ */
	sys8(2,6,0);	/* MIRS̕(face) */
	sys8(2,7,0);	/* x */
	sys8(2,8,0);	/* px */
	sys8(2,9,0);	/* ړ */
	
	sys2(2,ST_02,0,0);
	sys4(2);
	
	w=0;
	len=0;
	
	re_ts_data();
	
	rs_snd("task02 inzt end\n");

}


void nrmt02(int cm,int scm)	
{
}


void timt02(int cm, int scm){
	
	RE_TS_DATA data;	/* RE.rRE.lTSf[^̍\(RE and TS data) */
	float	v;	/* x[m/s] */
	float	w_old;	/* ߋ̊px */
	int ts_in;	/* TSf[^ݗp(TS input data) */
	int self_dir;	/* MIRŠĂ(MIRS facing direction) */
	
	rs_snd("task02 timt\n");
	
	data=re_ts_data();	/* RE&TSf[^ǂݍ */
	ts_in=0;
	BIT_W(ts_in,0,BIT_R(data.ts,0));	/* TS̓̓f[^H */
	BIT_W(ts_in,1,BIT_R(data.ts,1));
	BIT_W(ts_in,2,BIT_R(data.ts,2));
	sys8(2,5,ts_in);	/* BBTSf[^ */
	
	v = Kv*(float)(data.r+data.l);	/* x̌vZ */
	v = v*(100.f);
	w_old = w;	/* O̊pxf[^ۑ */
	w = ((data.r>data.l)*Kw_CCW+(data.r<data.l)*Kw_CW)*(float)(data.r-data.l);	/* px̌vZ */
	re_th += ((w+w_old)*DT)/2.f;	/* pxpx߂(ςƂĂ) */
	
	/* re_th+=(w*DT); */
	while(re_th<0.f){	/* px0`2΂܂łɂ */
		re_th += PI2;
	}
	while(re_th>=PI2){
		re_th -= PI2;
	}
	
	re_x += (v*DT*sinf(re_th));	/* xW̌vZ */
	re_y -= (v*DT*cosf(re_th));	/* yW̌vZ */
	
	if(re_x >  x_thre) re_x =  x_thre;	/* x,yWlimitɐ */
	if(re_x < -x_thre) re_x = -x_thre;
	if(re_y >  y_thre) re_y =  y_thre;
	if(re_y < -y_thre) re_y = -y_thre;
	
	len+=(v*DT);	/* ړʂ̌vZ */
	
	self_dir = (int)(((int)(DEG(re_th))+90)%360);	/* MIRS̕vZ */
	
	sys8(2,0,(int)(re_x));	/* BBxWAyW */
	sys8(2,1,(int)(re_y));
	sys8(2,2,(int)(DEG(re_th)));
	sys8(2,3,data.r);	/* BBɍEREf[^ */
	sys8(2,4,data.l);	/*sys8(2,5,ts_in); write Touch Sensor(TS) data*/
	sys8(2,6,self_dir);	/* BBMIRS̕ */
	sys8(2,7,(int)(v));	/* BBɑxApxAړʂ */
	sys8(2,8,(int)(DEG(w)));
	sys8(2,9,((int)len));
}


interrupt void intt02(){
}

